/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

/*
**	bitmap common bitblt functions 
**
**	this functions use cfbbitblt.c 
**
*/


void
BITBLTFUNC (pSrcDrawable, pDstDrawable, alu, prgnDst, pptSrc, pmask)
DrawablePtr pSrcDrawable;
DrawablePtr pDstDrawable;
unsigned char alu;
RegionPtr prgnDst;
DDXPointPtr pptSrc;
int	  pmask;
{
    unsigned int *psrcBase, *pdstBase;	/* start of src and dst bitmaps */
    int widthSrc, widthDst;	/* add to get to same position in next line */
    register BoxPtr pbox;
    int nbox;
    BoxPtr pboxNew1, pboxNew2; /* temporaries for shuffling rectangles */
    DDXPointPtr pptNew1, pptNew2; /* shuffling boxes entails shuffling the
				     source points too */
    int w, h;
    int xdir;			/* 1 = left right, -1 = right left/ */
    int ydir;			/* 1 = top down, -1 = bottom up */
    unsigned int *psrcLine, *pdstLine;	
				/* pointers to line with current src and dst */
				/* following used for looping through a line */
    register unsigned int *psrc;
    register unsigned int *pdst;
#ifndef	BITBLT1
    register          int  pm = pmask;
    unsigned int *pdstOrg;
#endif
#ifndef	BITBLT1
    unsigned int *psrcOrg;
#endif
    register unsigned int bits;
    register unsigned int bits1;
    int careful;
    int srcPlaneOffset;		/* source drawable plane size */
    int dstPlaneOffset;		/* dstnation drawble plane size */
    OmronFbInfoPtr fbInfo;
    int depth = pDstDrawable->depth;

#ifndef	BITBLT1
    initPmask(pmask, pDstDrawable->depth);
#endif

    if( ! pmask ) return;

    fbInfo = getOmronFbInfo( pSrcDrawable );

    setBaseAndWidth( pSrcDrawable, psrcBase, widthSrc, srcPlaneOffset );

    if(isCommonPlane(psrcBase,fbInfo))
    {
	psrcBase = (unsigned int *)getPlaneAddres(fbInfo);
    }

    setBaseAndWidth( pDstDrawable, pdstBase, widthDst, dstPlaneOffset );

    if(isCommonPlane(pdstBase,fbInfo))
    {
	pdstBase = (unsigned int *)getPlaneAddres(fbInfo);
	sx_set_operation_all( GXcopy, ~0 );
    }

    /* XXX we have to err on the side of safety when both are windows,
     * because we don't know if IncludeInferiors is being used.
     */
    careful = (pdstBase == psrcBase);

    checkRevSrc(psrcBase, srcPlaneOffset, pSrcDrawable->depth);

#ifndef	BITBLT1
    if(depth == 1)
    {
	if(copyPlaneBitPlane)
	{
	    psrcBase += (copyPlaneBitPlane - 1) * srcPlaneOffset;
	    pmask = (pm & 1) ? bitmapPmask() : 0;
	}
    }
    else if(pSrcDrawable->depth == 1)
   {
	srcPlaneOffset = 0;
   }
#endif

    pbox = REGION_RECTS(prgnDst);
    nbox = REGION_NUM_RECTS(prgnDst);

    checkAndChangeRectBox( careful, pptSrc, pbox, nbox,
                           pboxNew1, pptNew1, pboxNew2, pptNew,
                           ydir, xdir);


    { 
	register int    xoffSrc, xoffDst;
	int	leftShift, rightShift;

#ifdef	BITBLT1
	psrcBase += (copyPlaneBitPlane - 1) * srcPlaneOffset;
#endif

	while(nbox--)
	{
	    w = pbox->x2 - pbox->x1;
	    h = pbox->y2 - pbox->y1;

	    if (ydir == -1) /* start at last scanline of rectangle */
	    {
	        psrcLine = psrcBase + ((pptSrc->y+h-1) * -widthSrc);
	        pdstLine = pdstBase + ((pbox->y2-1) * -widthDst);
	    }
	    else /* start at first scanline */
	    {
	        psrcLine = psrcBase + (pptSrc->y * widthSrc);
    		pdstLine = pdstBase + (pbox->y1 * widthDst);
	     }

	    xoffDst = pbox->x1 & PIM;

	    /* width < PPW */
#if defined(FASTGETBITS) && defined(FASTPUTBITS)
	    if (w <= PPW)
#else
	    if ((xoffDst + w) <= PPW)
#endif
	    {	
#if	! (defined(FASTGETBITS) && defined(FASTPUTBIS))
		register int tmpmask; 
		maskpartialbits((xoffDst), (w), tmpmask);
#endif
		pdstLine += (pbox->x1 >> PWSH);
		psrcLine += (pptSrc->x >> PWSH);
		xoffSrc = pptSrc->x & PIM;

		while (h--)
		{  
		    psrc = psrcLine;
		    pdst = pdstLine;
#ifndef	BITBLT1
	            pm = pmask;
		    planeLoop(pm)
		    { 
			if(checkPmask(pm))
			{ /* check plane mask bit */ 
#endif
		    	    register unsigned int tmpbits;
#if	(defined(FASTGETBITS) && defined(FASTPUTBIS))
		    	    register unsigned int tmpbits1;

		   	    FASTGETBITS(psrc, xoffSrc, w, tmpbits);
    			    FASTGETBITS(pdst, xoffDst, w, tmpbits1);
			    tmpbits = ROPFNUC(tmpbits, tmpbits1);
    			    FASTPUTBITS(tmpbits, xoffDst, w, pdst);
#else
			    getbits(psrc, xoffSrc, w, tmpbits); 
		    	    slow_rop_putbits_port1( tmpbits, xoffDst, 
						    tmpmask, pdst,
					    	    ROPFUNC);
#endif
#ifndef	BITBLT1
			} 
		    	/* compute next plane address */ 
		    	psrc += srcPlaneOffset;
		    	pdst += dstPlaneOffset;
			updatePmask(pm);
		    } 
#endif
		    psrcLine += widthSrc;
		    pdstLine += widthDst;
		} 
	    }
	    else	/* width > PPW */
	    {
    		unsigned int startmask, endmask;
    		int nlMiddle;		/* whole longwords in dst */
    		register int nl;	/* temp copy of nlMiddle */
		register int tmp;
	    	maskbits(pbox->x1, w, startmask, endmask, nlMiddle);

	    	if (xdir == 1)
	    	{
	    	    xoffSrc = pptSrc->x & PIM;
		    pdstLine += (pbox->x1 >> PWSH);
		    psrcLine += (pptSrc->x >> PWSH);

		    if (xoffSrc == xoffDst)
		    { 
	    	    	while (h--)
			{   
#ifdef	BITBLT1
		    	    psrc = psrcLine;
		    	    pdst = pdstLine;
#else
			    pm = pmask;
		    	    psrcOrg = psrcLine;
		    	    pdstOrg = pdstLine;
			    planeLoop(pm) 
			    {
				psrc = psrcOrg;
				pdst = pdstOrg;
				if(checkPmask(pm))
				{
#endif
				    if (startmask)
				    {
					*pdst =
					  ((tmp = *pdst) & ~startmask) |
					  (ROPFUNC(*psrc++, tmp) & startmask);
					pdst++;
				    }
			    	    nl = nlMiddle;
#ifdef LARGE_INSTRUCTION_CACHE
#ifdef FAST_CONSTANT_OFFSET_MODE
			            psrc += nl & (UNROLL-1);
			            pdst += nl & (UNROLL-1);
#define BodyOdd(n) pdst[-n] = ROPFUNC(psrc[-n].pdst[-n]);
#define BodyEven(n) pdst[-n] = ROPFUNC(psrc[-n],pdst[-n]);
#define LoopReset \
    pdst += UNROLL; \
    psrc += UNROLL;
#else
#define BodyOdd(n)  *pdst = ROPFUNC(*psrc++,*pdst); \
		    pdst++;
#define BodyEven(n) BodyOdd(n)
#define LoopReset   ;
#endif
			    	    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
			    	    DuffL(nl, label1,
					  *pdst = ROPFUNC(*psrc++, *pdst);
					  pdst++;
					;)
#endif
				    if (endmask)
				    {
					*pdst =
					  ((tmp = *pdst) & ~endmask) |
					  (ROPFUNC(*psrc++, tmp) & endmask);
					pdst++;
				    }
#ifndef	BITBLT1
				} /* checkPmask() */
				updatePmask(pm);
				psrcOrg += srcPlaneOffset;
				pdstOrg += dstPlaneOffset;
			    } /* endLoop */
#endif
		    	    pdstLine += widthDst;
		    	    psrcLine += widthSrc;
			} /* h */
		    }
		    else /* xoffSrc == xoffDst */
		    {
		    	if (xoffSrc > xoffDst)
			{
			    leftShift = (xoffSrc - xoffDst);
			    rightShift = PPW - leftShift;
			}
		    	else
			{
			    rightShift = (xoffDst - xoffSrc);
			    leftShift = PPW - rightShift;
			}

		    	while (h--)
		    	{
#ifdef	BITBLT1
			    psrc = psrcLine;
			    pdst = pdstLine;
#else
			    pm = pmask;
			    psrcOrg = psrcLine;
			    pdstOrg = pdstLine;
			    planeLoop(pm)
			    {
				psrc = psrcOrg;
				pdst = pdstOrg;
				if(checkPmask(pm))
				{
#endif
				    bits = 0;
			 	    if (xoffSrc > xoffDst)
			    		bits = *psrc++;
				    if (startmask)
				    {
				    	bits1 = SCRLEFT(bits,leftShift);
				    	bits = *psrc++;
				    	bits1 |= SCRRIGHT(bits,rightShift);
				    	*pdst =
					  ((tmp = *pdst) & ~startmask) |
					  (ROPFUNC(bits1,tmp) & startmask);
				    	pdst++;
				    }
				    nl = nlMiddle;

#ifdef LARGE_INSTRUCTION_CACHE
				    bits1 = bits;
#ifdef FAST_CONSTANT_OFFSET_MODE
				    psrc += nl & (UNROLL-1);
				    pdst += nl & (UNROLL-1);
#define BodyOdd(n) \
    bits = psrc[-n]; \
    psdt[-n] = ROPFUNC((BitLeft(bits1, leftShift)|BitRight(bits, rightShift)), \
    		        pdst[-n]);
#define BodyEven(n) \
    bits1 = psrc[-n]; \
    pdst[-n] = ROPFUNC((BitLeft(bits, leftShift)|BitRight(bits1, rightShift)), \
			pdst[-n]);
#define LoopReset \
    pdst += UNROLL; \
    psrc += UNROLL;
#else
#define BodyOdd(n) \
    bits = *psrc++; \
    *psdt = ROPFUNC((BitLeft(bits1, leftShift)|BitRight(bits, rightShift)), \
    		        *pdst); \
    pdst++;
#define BodyEven(n) \
    bits1 = *psrc++; \
    *pdst = ROPFUNC((BitLeft(bits, leftShift)|BitRight(bits1, rightShift)), \
			*pdst); \
    pdst++;
#define LoopReset   ;
#endif	/* !FAST_CONSTANT_OFFSET_MODE */
				    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
				    DuffL (nl,label2,
					bits1 = BitLeft(bits, leftShift);
					bits = *psrc++;
					*pdst =ROPFUNC( (bits1 |
						BitRight(bits, rightShift)),
						*pdst );
					pdst++;
			    	    )
#endif
				    if (endmask)
				    {
				    	bits1 = SCRLEFT(bits, leftShift);
				    	if (SCRLEFT(endmask, rightShift))
				    	{
					    bits = *psrc++;
					    bits1 |= SCRRIGHT(bits, rightShift);
				    	}
				    	*pdst =
					  ((tmp = *pdst) & ~endmask) |
					  (ROPFUNC(bits1, tmp) & endmask);
				    }
#ifndef	BITBLT1
				} /* checkPmask() */
				updatePmask(pm);
				psrcOrg += srcPlaneOffset;
				pdstOrg += dstPlaneOffset;
			    } /* endLoop */
#endif
			    pdstLine += widthDst;
			    psrcLine += widthSrc;
		    	} /* h */
		    } /* xoffSrc == xoffDst */
	    	}
	    	else	/* xdir == -1 */
	    	{
	    	    xoffSrc = (pptSrc->x + w - 1) & PIM;
	    	    xoffDst = (pbox->x2 - 1) & PIM;
		    pdstLine += ((pbox->x2-1) >> PWSH) + 1;
		    psrcLine += ((pptSrc->x+w - 1) >> PWSH) + 1;
		    if (xoffSrc == xoffDst)
		    {
	    	    	while (h--)
	    	    	{
#ifdef	BITBLT1
			    psrc = psrcLine;
			    pdst = pdstLine;
#else
			    pm = pmask;
			    psrcOrg = psrcLine;
			    pdstOrg = pdstLine;
			    planeLoop(pm)
			    {
				psrc = psrcOrg;
				pdst = pdstOrg;
				if(checkPmask(pm))
				{
#endif
				    if (endmask)
				    {
				    	pdst--;
				    	*pdst =
					  ((tmp = *pdst) & ~endmask) |
					  (ROPFUNC(*--psrc, tmp) & endmask);
				    }
				    nl = nlMiddle;

#ifdef LARGE_INSTRUCTION_CACHE
#ifdef FAST_CONSTANT_OFFSET_MODE
				    psrc -= nl & (UNROLL - 1);
				    pdst -= nl & (UNROLL - 1);
#define BodyOdd(n) pdst[n-1] = ROPFUNC(psrc[n-1],pdst[-n]);
#define BodyEven(n) pdst[n-1] = ROPFUNC(psrc[n-1],pdst[-n]);
#define LoopReset \
    pdst -= UNROLL;\
    psrc -= UNROLL;
#else
#define BodyOdd(n)  --pdst; \
		    *pdst = ROPFUNC(*--psrc,*pdst);
		    
#define BodyEven(n) BodyOdd(n)
#define LoopReset   ;
#endif
				    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
				    DuffL(nl,label3, 
					  --pdst;
					  *pdst = ROPFUNC(*--psrc, *pdst);)
#endif
				    if (startmask)
				    {
				    	--pdst;
				    	*pdst =
					 ((tmp = *pdst) & ~startmask) |
					 (ROPFUNC(*--psrc,tmp) & startmask);
				    }
#ifndef	BITBLT1
				} /* checkPmask() */
				updatePmask(pm);
				psrcOrg += srcPlaneOffset;
				pdstOrg += dstPlaneOffset;
			    } /* endLoop */
#endif
		    	    pdstLine += widthDst;
		    	    psrcLine += widthSrc;
		    	} /* h */
		    }
		    else /* xoffSrc == xoffDst */
		    {
			if (xoffDst > xoffSrc)
			{
			    rightShift = (xoffDst - xoffSrc);
			    leftShift = PPW - rightShift;
			}
			else
			{
		    	    leftShift = (xoffSrc - xoffDst);
		    	    rightShift = PPW - leftShift;
			}
	    	    	while (h--)
	    	    	{
#ifdef	BITBLT1
			    psrc = psrcLine;
			    pdst = pdstLine;
#else
			    pm = pmask;
			    psrcOrg = psrcLine;
			    pdstOrg = pdstLine;
			    planeLoop( pm )
			    {
				psrc = psrcOrg;
				pdst = pdstOrg;
				if(checkPmask(pm))
				{
#endif
				    bits = 0;
				    if (xoffDst > xoffSrc)
					bits = *--psrc;
				    if (endmask)
				    {
				    	bits1 = SCRRIGHT(bits, rightShift);
				    	bits = *--psrc;
				    	bits1 |= SCRLEFT(bits, leftShift);
				    	pdst--;
				    	*pdst =
					  ((tmp = *pdst) & ~endmask) |
					  (ROPFUNC(bits1, tmp) & endmask);
				    }
				    nl = nlMiddle;
	
#ifdef LARGE_INSTRUCTION_CACHE
				    bits1 = bits;
#ifdef FAST_CONSTANT_OFFSET_MODE
				    psrc -= nl & (UNROLL - 1);
				    pdst -= nl & (UNROLL - 1);
#define BodyOdd(n) \
    bits = psrc[n-1]; \
    pdst[n-1] = ROPFUNC( \
	(BitRight(bits1, rightShift) | BitLeft(bits, leftShift)), \
	pdst[n-1]);
#define BodyEven(n) \
    bits1 = psrc[n-1]; \
    pdst[n-1] = ROPFUNC( \
	(BitRight(bits, rightShift) | BitLeft(bits1, leftShift)), \
	pdst[n-1]);
#define LoopReset \
    pdst -= UNROLL; \
    psrc -= UNROLL;
#else
#define BodyOdd(n) \
    bits = *--psrc;  pdst--;\
    *pdst = ROPFUNC( \
	(BitRight(bits1, rightShift) | BitLeft(bits, leftShift)), \
	*pdst);
#define BodyEven(n) \
    bits1 = *--psrc;  pdst--;\
    *pdst =  ROPFUNC( \
	(BitRight(bits, rightShift) | BitLeft(bits1, leftShift)), \
	*pdst);
#define LoopReset   ;
#endif
				    PackedLoop
#undef BodyOdd
#undef BodyEven
#undef LoopReset
#else
				    DuffL (nl, label4,
					bits1 = BitRight(bits, rightShift);
					bits = *--psrc;
					pdst--;
					*pdst = ROPFUNC(
					  (bits1 | BitLeft(bits, leftShift)),
					  *pdst);
				    )
#endif
				    if (startmask)
				    {
				    	bits1 = SCRRIGHT(bits, rightShift);
				    	if (SCRRIGHT (startmask, leftShift))
				    	{
					    bits = *--psrc;
					    bits1 |= SCRLEFT(bits, leftShift);
				    	}
				    	--pdst;
				    	*pdst = ((tmp = *pdst) & ~startmask) |
					   (ROPFUNC(bits1, tmp) & startmask);
				    }
#ifndef	BITBLT1
				} /* checkPmask() */
				updatePmask(pm);
				psrcOrg += srcPlaneOffset;
				pdstOrg += dstPlaneOffset;
			    } /* endLoop */
#endif
		    	    pdstLine += widthDst;
		    	    psrcLine += widthSrc;
		    	} /* h */
		    } /* xoffSrc == xoffDst */
	    	} /* xdir */
	    } /* width */
	    pbox++;
	    pptSrc++;
	} /* nbox */
    }

    /* free up stuff */
    if (pboxNew2)
    {
	DEALLOCATE_LOCAL(pptNew2);
	DEALLOCATE_LOCAL(pboxNew2);
    }
    if (pboxNew1)
    {
	DEALLOCATE_LOCAL(pptNew1);
	DEALLOCATE_LOCAL(pboxNew1);
    }
}
