/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#include "X.h"
#include "Xmd.h"
#include "servermd.h"
#include "gcstruct.h"
#include "window.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "windowstr.h"

#include "cfb.h"
#include "cfbmskbits.h"

#define TILEFS32(ROP) \
    while (n--) \
    { \
	Pdst = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH); \
	srcy = ppt->y % tileHeight; \
	Psrc = psrc; \
	if ( ((ppt->x & PIM) + *pwidth) < PPW) \
	{ \
	    maskpartialbits(ppt->x, *pwidth, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    src = Psrc[srcy]; \
		    pdst = Pdst; \
		    *pdst = ((ROP(src, *pdst) & \
				startmask) | (*pdst & ~startmask)); \
		} \
		Psrc += srcpljmp; \
		Pdst += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(ppt->x, *pwidth, startmask, endmask, nlmiddle); \
	    if (startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			src = Psrc[srcy]; \
			pdst = Pdst; \
			*pdst = ((ROP(src, *pdst) & \
				startmask) | (*pdst & ~startmask)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(src, *pdst); \
			    pdst++; \
			} \
			*pdst = ((ROP(src, *pdst) & \
				endmask) | (*pdst & ~endmask)); \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			src = Psrc[srcy]; \
			pdst = Pdst; \
			*pdst = ((ROP(src, *pdst) & \
				startmask) | (*pdst & ~startmask)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(src, *pdst); \
			    pdst++; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			src = Psrc[srcy]; \
			pdst = Pdst; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(src, *pdst); \
			    pdst++; \
			} \
			*pdst = ((ROP(src, *pdst) & \
				endmask) | (*pdst & ~endmask)); \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			src = Psrc[srcy]; \
			pdst = Pdst; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(src, *pdst); \
			    pdst++; \
			} \
		    } \
		    Psrc += srcpljmp; \
		    Pdst += dstpljmp; \
		} \
	    } \
	} \
	pwidth++; \
	ppt++; \
    }

/* Fill spans with tiles that are 32 bits wide */
void
cfbTileFS(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted)
DrawablePtr pDrawable;
GC		*pGC;
int		nInit;		/* number of spans to fill */
DDXPointPtr pptInit;		/* pointer to list of start points */
int *pwidthInit;		/* pointer to list of n widths */
int fSorted;
{
				/* next three parameters are post-clip */
    register int n;		/* number of spans to fill */
    register DDXPointPtr ppt;	/* pointer to list of start points */
    register int *pwidth;	/* pointer to list of n widths */
    int	*addrlBase;		/* pointer to start of bitmap */
    int	nlwidth;		/* width in longwords of bitmap */
    register int *pdst;		/* pointer to current word in bitmap */
    int *Pdst;
    register unsigned long src;
    register int nlw;
    int nlmiddle;
    register int startmask;
    register int endmask;
    PixmapPtr pTile;		/* pointer to stipple we want to fill with */
    int *psrc, *Psrc;
    int tileHeight;
    int *pwidthFree;		/* copies of the pointers to free */
    DDXPointPtr pptFree;
    unsigned long planemask;
    register int plane;
    int srcpljmp, dstpljmp;
    int rop, depth;
    int srcy;
    OmronFbInfoPtr fbInfo;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    n = nInit * miFindMaxBand(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip);
    pwidthFree = (int *)ALLOCATE_LOCAL(n * sizeof(int));
    pptFree = (DDXPointRec *)ALLOCATE_LOCAL(n * sizeof(DDXPointRec));
    if(!pptFree || !pwidthFree)
    {
	if (pptFree) DEALLOCATE_LOCAL(pptFree);
	if (pwidthFree) DEALLOCATE_LOCAL(pwidthFree);
	return;
    }
    pwidth = pwidthFree;
    ppt = pptFree;
    n = miClipSpans(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip,
		     pptInit, pwidthInit, nInit, 
		     ppt, pwidth, fSorted);

    pTile = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pRotatedPixmap;

    rop = pGC->alu;
    depth = pDrawable->depth;
    planemask = pGC->planemask;
    tileHeight = pTile->drawable.height;
    psrc = (int *)(pTile->devPrivate.ptr);
    srcpljmp = (pTile->devKind >> 2) * tileHeight;

    for (plane = 0; plane < depth; plane++)
    {
	cfbplmk[plane] = (planemask >> plane) & 0x1;
    }

    fbInfo = getOmronFbInfo(pDrawable);

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	addrlBase = (int *)getPlaneAddres(fbInfo);
	nlwidth = (int)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;
	dstpljmp = getFbPlaneLongSize();

	sx_plane_select(planemask);

	while (n--)
	{
	    Pdst = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH);
	    srcy = ppt->y % tileHeight;
	    Psrc = psrc;

	    /* all bits inside same longword */
	    if ( ((ppt->x & PIM) + *pwidth) < PPW)
	    {
		maskpartialbits(ppt->x, *pwidth, startmask);
		sx_set_op(rop, startmask);
		for (plane = 0; plane < depth; plane++)
		{
		    if (cfbplmk[plane])
		    {
			pdst = Pdst;
			src = Psrc[srcy];
			*pdst = src;
		    }
		    Pdst += dstpljmp;
		    Psrc += srcpljmp;
		}
	    }
	    else
	    {
		maskbits(ppt->x, *pwidth, startmask, endmask, nlmiddle);
		if (startmask && endmask)
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    pdst = Pdst;
			    src = Psrc[srcy];
			    sx_set_op(rop, startmask);
			    *pdst = src;
			    pdst++;
			    sx_set_op(rop, ALL_ONE);
			    nlw = nlmiddle;
			    Duff(nlw, *pdst++ = src);
			    sx_set_op(rop, endmask);
			    *pdst = src;
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else if (startmask && !endmask)
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    pdst = Pdst;
			    src = Psrc[srcy];
			    sx_set_op(rop, startmask);
			    *pdst = src;
			    pdst++;
			    sx_set_op(rop, ALL_ONE);
			    nlw = nlmiddle;
			    Duff(nlw, *pdst++ = src);
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else if (!startmask && endmask)
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    pdst = Pdst;
			    src = Psrc[srcy];
			    sx_set_op(rop, ALL_ONE);
			    nlw = nlmiddle;
			    Duff(nlw, *pdst++ = src);
			    sx_set_op(rop, endmask);
			    *pdst = src;
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
		else
		{
		    for (plane = 0; plane < depth; plane++)
		    {
			if (cfbplmk[plane])
			{
			    pdst = Pdst;
			    src = Psrc[srcy];
			    sx_set_op(rop, ALL_ONE);
			    nlw = nlmiddle;
			    Duff(nlw, *pdst++ = src);
			}
			Pdst += dstpljmp;
			Psrc += srcpljmp;
		    }
		}
	    }
	    pwidth++;
	    ppt++;
	}
    }
    else
    {
	addrlBase = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	dstpljmp = nlwidth * pDrawable->height;
	if(isCommonPlane( addrlBase, fbInfo ))
	{
	    addrlBase = (int *)getPlaneAddres(fbInfo);
	    sx_set_operation_all( GXcopy, ~0 );
	}

	switch(rop)
	{
	    case GXcopy:
		TILEFS32(fnCOPY);
		break;
	    case GXxor:
		TILEFS32(fnXOR);
		break;
	    case GXand:
		TILEFS32(fnAND);
		break;
	    case GXor:
		TILEFS32(fnOR);
		break;
	    case GXset:
		TILEFS32(fnSET);
		break;
	    case GXclear:
		TILEFS32(fnCLEAR);
		break;
	    case GXandReverse:
		TILEFS32(fnANDREVERSE);
		break;
	    case GXandInverted:
		TILEFS32(fnANDINVERTED);
		break;
	    case GXnor:
		TILEFS32(fnNOR);
		break;
	    case GXequiv:
		TILEFS32(fnEQUIV);
		break;
	    case GXinvert:
		TILEFS32(fnINVERT);
		break;
	    case GXorReverse:
		TILEFS32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		TILEFS32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		TILEFS32(fnORINVERTED);
		break;
	    case GXnand:
		TILEFS32(fnNAND);
		break;
	    default:
		break;
	}
    }
    DEALLOCATE_LOCAL(pptFree);
    DEALLOCATE_LOCAL(pwidthFree);
}

#define STIPFS32(ROP) \
    while (n--) \
    { \
	dstLine = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH); \
	src = psrc[ppt->y % stippleHeight]; \
	if ( ((ppt->x & PIM) + *pwidth) < PPW) \
	{ \
	    unsigned int mask1, mask2; \
	    maskpartialbits(ppt->x, *pwidth, startmask); \
	    mask1 = startmask & src; \
	    mask2 = ~startmask | ~src; \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    pdst = dstLine; \
		    tmpsrc = src & cfbfgmk[plane]; \
		    *pdst = ((ROP(tmpsrc, *pdst) & mask1) | \
			    (*pdst & mask2)); \
		} \
		dstLine += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    unsigned int mask1, mask2; \
	    unsigned int mask3, mask4; \
	    maskbits(ppt->x, *pwidth, startmask, endmask, nlmiddle); \
	    if (startmask && endmask) \
	    { \
		mask1 = startmask & src; \
		mask2 = ~startmask | ~src; \
		mask3 = endmask & src; \
		mask4 = ~endmask | ~src; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = src & cfbfgmk[plane]; \
			*pdst = ((ROP(tmpsrc, *pdst) & mask1) | \
				(*pdst & mask2)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ((ROP(tmpsrc, *pdst) & src) | \
					(*pdst & ~src)); \
			    pdst++; \
			} \
			*pdst = ((ROP(tmpsrc, *pdst) & mask3) | \
				(*pdst & mask4)); \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		mask1 = startmask & src; \
		mask2 = ~startmask | ~src; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = src & cfbfgmk[plane]; \
			*pdst = ((ROP(tmpsrc, *pdst) & mask1) | \
				(*pdst & mask2)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ((ROP(tmpsrc, *pdst) & src) | \
					(*pdst & ~src)); \
			    pdst++; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		mask1 = endmask & src; \
		mask2 = ~endmask | ~src; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = src & cfbfgmk[plane]; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ((ROP(tmpsrc, *pdst) & src) | \
					(*pdst & ~src)); \
			    pdst++; \
			} \
			*pdst = ((ROP(tmpsrc, *pdst) & mask1) | \
				(*pdst & mask2)); \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = src & cfbfgmk[plane]; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ((ROP(tmpsrc, *pdst) & src) | \
					(*pdst & ~src)); \
			    pdst++; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	} \
	pwidth++; \
	ppt++; \
    }

/* Fill spans with stipples that are 32 bits wide */
void
cfbStippleFS(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted)
DrawablePtr pDrawable;
GC		*pGC;
int		nInit;		/* number of spans to fill */
DDXPointPtr pptInit;		/* pointer to list of start points */
int *pwidthInit;		/* pointer to list of n widths */
int fSorted;
{
				/* next three parameters are post-clip */
    register int n;		/* number of spans to fill */
    register DDXPointPtr ppt;	/* pointer to list of start points */
    register int *pwidth;	/* pointer to list of n widths */
    int *addrlBase;		/* pointer to start of bitmap */
    int nlwidth;		/* width in longwords of bitmap */
    register int *pdst;		/* pointer to current word in bitmap */
    int *dstLine;
    register unsigned long src;
    register int nlw;
    register int startmask;
    register int endmask;
    PixmapPtr pStipple;		/* pointer to stipple we want to fill with */
    int *psrc;
    int stippleHeight;
    int nlmiddle;
    int *pwidthFree;		/* copies of the pointers to free */
    DDXPointPtr pptFree;
    unsigned long planemask;
    unsigned long pixel;
    int rop;
    int depth;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    n = nInit * miFindMaxBand(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip);
    pwidthFree = (int *)ALLOCATE_LOCAL(n * sizeof(int));
    pptFree = (DDXPointRec *)ALLOCATE_LOCAL(n * sizeof(DDXPointRec));
    if(!pptFree || !pwidthFree)
    {
	if (pptFree) DEALLOCATE_LOCAL(pptFree);
	if (pwidthFree) DEALLOCATE_LOCAL(pwidthFree);
	return;
    }
    pwidth = pwidthFree;
    ppt = pptFree;
    n = miClipSpans(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip,
		     pptInit, pwidthInit, nInit, 
		     ppt, pwidth, fSorted);

    pStipple = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pRotatedPixmap;

    if (pStipple->drawable.depth != 1) {
	FatalError( "Stipple depth not equal to 1!\n" );
    }

    rop = pGC->alu;
    depth = pDrawable->depth;
    planemask = pGC->planemask;
    pixel = pGC->fgPixel;
    stippleHeight = pStipple->drawable.height;
    psrc = (int *)(pStipple->devPrivate.ptr);

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	addrlBase = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;

	sx_check_transparent(rop, ALL_ONE, pixel, planemask);
	sx_plane_select(planemask);

	while (n--)
	{
	    pdst = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH);
	    src = psrc[ppt->y % stippleHeight];

	    /* all bits inside same longword */
	    if ( ((ppt->x & PIM) + *pwidth) < PPW)
	    {
		maskpartialbits(ppt->x, *pwidth, startmask);
		*pdst = src & startmask;
	    }
	    else
	    {
		maskbits(ppt->x, *pwidth, startmask, endmask, nlw);
		if (startmask)
		    *pdst++ = src & startmask;
		Duff(nlw, *pdst++ = src);
		if (endmask)
		    *pdst = src & endmask;
	    }
	    pwidth++;
	    ppt++;
	}
    }
    else
    {
	int dstpljmp;
	register int plane;
	unsigned long tmpsrc;
	OmronFbInfoPtr fbInfo;

	addrlBase = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	dstpljmp = nlwidth * pDrawable->height;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( addrlBase, fbInfo ))
	    addrlBase = (int *) fbInfo->plane;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbfgmk[plane] = ((pixel >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	}

	switch(rop)
	{
	    case GXcopy:
		STIPFS32(fnCOPY);
		break;
	    case GXxor:
		STIPFS32(fnXOR);
		break;
	    case GXand:
		STIPFS32(fnAND);
		break;
	    case GXor:
		STIPFS32(fnOR);
		break;
	    case GXset:
		STIPFS32(fnSET);
		break;
	    case GXclear:
		STIPFS32(fnCLEAR);
		break;
	    case GXandReverse:
		STIPFS32(fnANDREVERSE);
		break;
	    case GXandInverted:
		STIPFS32(fnANDINVERTED);
		break;
	    case GXnor:
		STIPFS32(fnNOR);
		break;
	    case GXequiv:
		STIPFS32(fnEQUIV);
		break;
	    case GXinvert:
		STIPFS32(fnINVERT);
		break;
	    case GXorReverse:
		STIPFS32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		STIPFS32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		STIPFS32(fnORINVERTED);
		break;
	    case GXnand:
		STIPFS32(fnNAND);
		break;
	    default:
		break;
	}
    }
    DEALLOCATE_LOCAL(pptFree);
    DEALLOCATE_LOCAL(pwidthFree);
}

#define OPSTIPFS32(ROP) \
    while (n--) \
    { \
	dstLine = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH); \
	src = psrc[ppt->y % stippleHeight]; \
	if ( ((ppt->x & PIM) + *pwidth) < PPW) \
	{ \
	    maskpartialbits(ppt->x, *pwidth, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    pdst = dstLine; \
		    tmpsrc = ((src & cfbfgmk[plane]) | \
				(~src & cfbbgmk[plane])); \
		    *pdst = ((ROP(tmpsrc, *pdst) & startmask) | \
			    (*pdst & ~startmask)); \
		} \
		dstLine += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(ppt->x, *pwidth, startmask, endmask, nlmiddle); \
	    if (startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = ((src & cfbfgmk[plane]) | \
					(~src & cfbbgmk[plane])); \
			*pdst = ((ROP(tmpsrc, *pdst) & startmask) | \
				(*pdst & ~startmask)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(tmpsrc, *pdst); \
			    pdst++; \
			} \
			*pdst = ((ROP(tmpsrc, *pdst) & endmask) | \
				(*pdst & ~endmask)); \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = ((src & cfbfgmk[plane]) | \
					(~src & cfbbgmk[plane])); \
			*pdst = ((ROP(tmpsrc, *pdst) & startmask) | \
				(*pdst & ~startmask)); \
			pdst++; \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(tmpsrc, *pdst); \
			    pdst++; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = ((src & cfbfgmk[plane]) | \
					(~src & cfbbgmk[plane])); \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(tmpsrc, *pdst); \
			    pdst++; \
			} \
			*pdst = ((ROP(tmpsrc, *pdst) & endmask) | \
				(*pdst & ~endmask)); \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			pdst = dstLine; \
			tmpsrc = ((src & cfbfgmk[plane]) | \
					(~src & cfbbgmk[plane])); \
			nlw = nlmiddle; \
			while (nlw--) \
			{ \
			    *pdst = ROP(tmpsrc, *pdst); \
			    pdst++; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	} \
	pwidth++; \
	ppt++; \
    }


#define compute_1toN_operation( alu, fg, bg, pm1, pm2, pm3, pm4, pmask) \
{ \
	unsigned long diff = fg ^ bg; \
	unsigned long same = ~diff; \
	pm1 = same & (~fg); \
	pm2 = diff & bg; \
	pm3 = diff & fg; \
	pm4 = same & fg; \
	if(conv_op_table[alu] == GXnoop) \
		pmask &= ~pm1; \
	if(invert_op_table[alu] == GXnoop) \
		pmask &= ~pm2; \
	if(const_src_op_table[alu] == GXnoop) \
		pmask &= ~pm4; \
}

#define	sx_set_1toN_operation(alu, mask, pm1, pm2, pm3, pm4, pmask) \
{ \
	sx_plane_select(pm1); \
	*sx_conv_op_cont0[alu] = mask; \
	sx_plane_select(pm2); \
	*sx_invert_op_cont0[alu] = mask; \
	sx_plane_select(pm3); \
	*sx_op_cont0[alu] = mask; \
	sx_plane_select(pm4); \
	*sx_const_src_op_cont0[alu] = mask; \
	sx_plane_select(pmask); \
}

/* Fill spans with opaquestipples that are 32 bits wide */
void
cfbOpStipFS(pDrawable, pGC, nInit, pptInit, pwidthInit, fSorted)
DrawablePtr pDrawable;
GC		*pGC;
int		nInit;		/* number of spans to fill */
DDXPointPtr pptInit;		/* pointer to list of start points */
int *pwidthInit;		/* pointer to list of n widths */
int fSorted;
{
				/* next three parameters are post-clip */
    register int n;		/* number of spans to fill */
    register DDXPointPtr ppt;	/* pointer to list of start points */
    register int *pwidth;	/* pointer to list of n widths */
    int *addrlBase;		/* pointer to start of bitmap */
    int nlwidth;		/* width in longwords of bitmap */
    register int *pdst;		/* pointer to current word in bitmap */
    int *dstLine;
    register unsigned long src;
    register int nlw;
    register int startmask;
    register int endmask;
    PixmapPtr pStipple;		/* pointer to stipple we want to fill with */
    int *psrc;
    int stippleHeight;
    int nlmiddle;
    int *pwidthFree;		/* copies of the pointers to free */
    DDXPointPtr pptFree;
    unsigned long planemask;
    unsigned long pm1, pm2, pm3, pm4;
    unsigned long fg, bg;
    int rop;
    int depth;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    n = nInit * miFindMaxBand(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip);
    pwidthFree = (int *)ALLOCATE_LOCAL(n * sizeof(int));
    pptFree = (DDXPointRec *)ALLOCATE_LOCAL(n * sizeof(DDXPointRec));
    if(!pptFree || !pwidthFree)
    {
	if (pptFree) DEALLOCATE_LOCAL(pptFree);
	if (pwidthFree) DEALLOCATE_LOCAL(pwidthFree);
	return;
    }
    pwidth = pwidthFree;
    ppt = pptFree;
    n = miClipSpans(((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pCompositeClip,
		     pptInit, pwidthInit, nInit, 
		     ppt, pwidth, fSorted);

    pStipple = ((cfbPrivGC *)(pGC->devPrivates[cfbGCPrivateIndex].ptr))->pRotatedPixmap;

    if (pStipple->drawable.depth != 1) {
	FatalError( "Stipple depth not equal to 1!\n" );
    }

    rop = pGC->alu;
    depth = pDrawable->depth;
    planemask = pGC->planemask;
    fg = pGC->fgPixel;
    bg = pGC->bgPixel;
    stippleHeight = pStipple->drawable.height;
    psrc = (int *)(pStipple->devPrivate.ptr);

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	addrlBase = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	nlwidth = (int)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;

        compute_1toN_operation( rop, fg, bg, pm1, pm2, pm3, pm4, planemask) \

	while (n--)
	{
	    pdst = addrlBase + (ppt->y * nlwidth) + (ppt->x >> PWSH);
	    src = psrc[ppt->y % stippleHeight];

	    /* all bits inside same longword */
	    if ( ((ppt->x & PIM) + *pwidth) < PPW)
	    {
		maskpartialbits(ppt->x, *pwidth, startmask);
		sx_set_1toN_operation(rop, startmask, pm1, pm2, pm3, pm4,
					   planemask);
		sx_plane_select(planemask);
		*pdst = src;
	    }
	    else
	    {
		unsigned long bgsrc;
		int *tmpdst = pdst;

		maskbits(ppt->x, *pwidth, startmask, endmask, nlmiddle);
		if (startmask)
		{
		    sx_set_1toN_operation(rop, startmask, pm1, pm2, pm3, pm4,
					   planemask);
		    sx_plane_select(planemask);
		    *pdst++ = src;
		}
		if((nlw = nlmiddle) > 0)
		{
		    sx_set_1toN_operation(rop, ~0, pm1, pm2, pm3, pm4,
					   planemask);
		    sx_plane_select(planemask);
		    Duff(nlw, *pdst++ = src);
		}
		if (endmask)
		{
		    sx_set_1toN_operation(rop, endmask, pm1, pm2, pm3, pm4,
					   planemask);
		    sx_plane_select(planemask);
		    *pdst++ = src;
		}
	    }
	    pwidth++;
	    ppt++;
	}
    }
    else
    {
	int dstpljmp;
	register int plane;
	unsigned long tmpsrc;
	OmronFbInfoPtr fbInfo;

	addrlBase = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwidth = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	dstpljmp = nlwidth * pDrawable->height;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( addrlBase, fbInfo ))
	{
	    addrlBase = (int *)getPlaneAddres(fbInfo);
	    sx_set_operation_all( GXcopy, ~0 );
	}

	for (plane = 0; plane < depth; plane++)
	{
	    cfbfgmk[plane] = ((fg >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbbgmk[plane] = ((bg >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	}

	switch(rop)
	{
	    case GXcopy:
		OPSTIPFS32(fnCOPY);
		break;
	    case GXxor:
		OPSTIPFS32(fnXOR);
		break;
	    case GXand:
		OPSTIPFS32(fnAND);
		break;
	    case GXor:
		OPSTIPFS32(fnOR);
		break;
	    case GXset:
		OPSTIPFS32(fnSET);
		break;
	    case GXclear:
		OPSTIPFS32(fnCLEAR);
		break;
	    case GXandReverse:
		OPSTIPFS32(fnANDREVERSE);
		break;
	    case GXandInverted:
		OPSTIPFS32(fnANDINVERTED);
		break;
	    case GXnor:
		OPSTIPFS32(fnNOR);
		break;
	    case GXequiv:
		OPSTIPFS32(fnEQUIV);
		break;
	    case GXinvert:
		OPSTIPFS32(fnINVERT);
		break;
	    case GXorReverse:
		OPSTIPFS32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		OPSTIPFS32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		OPSTIPFS32(fnORINVERTED);
		break;
	    case GXnand:
		OPSTIPFS32(fnNAND);
		break;
	    default:
		break;
	}
    }
    DEALLOCATE_LOCAL(pptFree);
    DEALLOCATE_LOCAL(pwidthFree);
}
