/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

/*
 * cfbplanebit.c
 *
 * omron color frame buffer utility routines
 */

#include	"X.h"
#include	"Xmd.h"
#include	"Xproto.h"
#include	"fontstruct.h"
#include	"dixfontstr.h"
#include	"gcstruct.h"
#include	"windowstr.h"
#include	"scrnintstr.h"
#include	"pixmapstr.h"
#include	"regionstr.h"
#include	"cfb.h"
#include	"cfbmskbits.h"
#include	"cfbfastblt.h"
#include	"cfbplanebit.h"


/*
**	common data
*/
unsigned char		cfbPlaneCopyType[32];
unsigned char		cfbTranCopyType[32];
         int		cfbTranRop = -1;
unsigned long		cfbPlanePixelsfg;
unsigned long		cfbTranPixelsfg;
unsigned long		cfbPlanePixelsbg;
unsigned long		copyPlaneBitPlane;
unsigned long		cfbPlaneMask;
unsigned long		cfbTranMask;
int			cfbPlaneRevFlag = 0;

void
cfbPlaneSetPixels (fg, bg, depth, pmask)
unsigned long	fg, bg;
int	depth;
unsigned long pmask;
{

    register int i;
    register unsigned long diff = fg ^ bg;
    register unsigned long m;

    /* copy new status */
    cfbPlanePixelsfg = fg;
    cfbPlanePixelsbg = bg;
    cfbPlaneMask     = pmask;

    /* 1th mask bits */
    m = 1;

    /* check fg and bg pixels */
    for( i = 0; i < depth; i++)
    {
	if(pmask & m)	/* enable planemask */
	{
	    if(diff & m)	/* fg != bg */
	    {
		if(fg & m)
		{
		    cfbPlaneCopyType[i] = CopySrc;
		}
	 	else
		{
		    cfbPlaneCopyType[i] = CopyInv;
		}
	    }
	    else
	    {
	    	if(fg & m)
		{
		    cfbPlaneCopyType[i] = FillSet;
		}
	    	else
		{
		    cfbPlaneCopyType[i] = FillClear;
		}
	    }
	}
	else
	{
	    cfbPlaneCopyType[i] = CopyNoop;
	}
	m <<= 1;
    }
}

void
cfbTranSetPixels (fg, rop, depth, pmask)
unsigned long	fg;
int	rop;
int	depth;
unsigned long pmask;
{

    register int i;
    register unsigned long m;
    register int pix;

    /* copy new status */
    cfbTranPixelsfg = fg;
    cfbTranMask     = pmask;
    cfbTranRop      = rop;
    

    /* create mask bit patten */
    m = 1;

    /* check fg and bg pixels */
    for( i = 0; i < depth; i++)
    {
	if(pmask & m)
	{
	    pix = (fg & m) ? 1 : 0;
	    cfbTranCopyType[i] = mfbReduceRop( rop, pix );
	}
	else
	{
	    cfbTranCopyType[i] = GXnoop;
	}
	m <<= 1;
    }
}


int
findBits( pmask, depth )
    register unsigned long pmask;
    int depth;
{
    register int i;

    pmask <<= 32 - depth;

    if(pmask) {
	for(i = depth; (pmask & 0x80000000) == 0; i--)
	{
	    pmask <<= 1;
	}
    } 
    else
    {
	i = 0;
    }

    return i;
}
