/***********************************************************
Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

/*
 * Fill 32 bit stippled and opaquestippled rectangles
 */

#include "X.h"
#include "Xmd.h"
#include "servermd.h"
#include "gcstruct.h"
#include "window.h"
#include "pixmapstr.h"
#include "scrnintstr.h"
#include "windowstr.h"

#include "cfb.h"
#include "cfbmskbits.h"

#define BOXOPSTIP32(ROP) \
    while (nBox--) \
    { \
	w = pBox->x2 - pBox->x1; \
	height = pBox->y2 - pBox->y1; \
	iy = pBox->y1 % stippleHeight; \
	dstLine = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH); \
	if (((pBox->x1 & PIM) + w) <= PPW) \
	{ \
	    maskpartialbits(pBox->x1, w, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    h = height; srcy = iy; \
		    pdst = dstLine; \
		    while (h--) \
		    { \
			bits = psrc[srcy]; \
			++srcy; \
			if (srcy == stippleHeight) \
			    srcy = 0; \
			tmpsrc = (bits & cfbfgmk[plane]) | \
				(~bits & cfbbgmk[plane]); \
			*pdst = ((ROP(tmpsrc, *pdst) & \
				startmask) | (*pdst & ~startmask)); \
			pdst += nlwDst; \
		    } \
		} \
		dstLine += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(pBox->x1, w, startmask, endmask, nlwMiddle); \
	    nlwExtra = nlwDst - nlwMiddle; \
	    if (startmask && endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = (bits & cfbfgmk[plane]) | \
					(~bits & cfbbgmk[plane]); \
			    *pdst = ((ROP(tmpsrc, *pdst) & startmask) | \
					(*pdst & ~startmask)); \
			    pdst++; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = ROP(tmpsrc, *pdst); \
				pdst++; \
			    } \
			    *pdst = ((ROP(tmpsrc, *pdst) & endmask) | \
					(*pdst & ~endmask)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = (bits & cfbfgmk[plane]) | \
					(~bits & cfbbgmk[plane]); \
			    *pdst = ((ROP(tmpsrc, *pdst) & startmask) | \
					(*pdst & ~startmask)); \
			    pdst++; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = ROP(tmpsrc, *pdst); \
				pdst++; \
			    } \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = (bits & cfbfgmk[plane]) | \
					(~bits & cfbbgmk[plane]); \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = ROP(tmpsrc, *pdst); \
				pdst++; \
			    } \
			    *pdst = ((ROP(tmpsrc, *pdst) & endmask) | \
					(*pdst & ~endmask)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = (bits & cfbfgmk[plane]) | \
					(~bits & cfbbgmk[plane]); \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = ROP(tmpsrc, *pdst); \
				pdst++; \
			    } \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	} \
	pBox++; \
    }

#define compute_1toN_operation( alu, fg, bg, pm1, pm2, pm3, pm4, pmask) \
{ \
	unsigned long diff = fg ^ bg; \
	unsigned long same = ~diff; \
	pm1 = same & (~fg); \
	pm2 = diff & bg; \
	pm3 = diff & fg; \
	pm4 = same & fg; \
	if(conv_op_table[alu] == GXnoop) \
		pmask &= ~pm1; \
	if(invert_op_table[alu] == GXnoop) \
		pmask &= ~pm2; \
	if(const_src_op_table[alu] == GXnoop) \
		pmask &= ~pm4; \
}

#define	sx_set_1toN_operation(alu, mask, pm1, pm2, pm3, pm4, pmask) \
{ \
	sx_plane_select(pm1); \
	*sx_conv_op_cont0[alu] = mask; \
	sx_plane_select(pm2); \
	*sx_invert_op_cont0[alu] = mask; \
	sx_plane_select(pm3); \
	*sx_op_cont0[alu] = mask; \
	sx_plane_select(pm4); \
	*sx_const_src_op_cont0[alu] = mask; \
	sx_plane_select(pmask); \
}

void
cfbFillBoxOpStip32 (pDrawable, pGC, nBox, pBox, stipple)
    DrawablePtr	    pDrawable;
    GCPtr           pGC;
    int		    nBox;	/* number of boxes to fill */
    register BoxPtr pBox;	/* pointer to list of boxes to fill */
    PixmapPtr	    stipple;	/* rotated, expanded stipple */
{
    register int *psrc;	/* pointer to bits in stipple, if needed */
    int stippleHeight;	/* height of the stipple */

    int nlwDst;		/* width in longwords of the dest pixmap */
    int w;		/* width of current box */
    register int h;	/* height of current box */
	     int hTmp;
    unsigned long fg, bg;	/* pixel values */
    unsigned long startmask;
    unsigned long endmask;	/* masks for reggedy bits at either end of line */
    int nlwMiddle;		/* number of longwords between sides of boxes */
    register int nlw;		/* loop version of nlwMiddle */
    register int *dstLine;
    register int *pdst;		/* pointer to bits we're writing */
   	     int *ptmp;
   	     int *pnext;
    register int srcy;		/* current stipple position */
    register int srcyTmp;		/* current stipple position */
    int iy, height;
    int nlwExtra;

    int *pbits;				/* pointer to start of pixmap */
    register unsigned long bits;	/* bits from stipple */
    unsigned long planemask;
    unsigned long pm1, pm2, pm3, pm4;
    int rop;
    int depth;
    int drawFg, drawBg;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    depth = pDrawable->depth;
    rop = pGC->alu;
    fg = pGC->fgPixel;
    bg = pGC->bgPixel;
    planemask = pGC->planemask;

    stippleHeight = stipple->drawable.height;
    psrc = (int *)stipple->devPrivate.ptr;

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pbits = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	nlwDst = (int)
		  (((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;

	compute_1toN_operation( rop, fg, bg, pm1, pm2, pm3, pm4, planemask) \

	while (nBox--)
	{
	    w = pBox->x2 - pBox->x1;
	    h = height = pBox->y2 - pBox->y1;
	    srcyTmp = iy = pBox->y1 % stippleHeight;
	    dstLine = pdst = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH);
	    if (((pBox->x1 & PIM) + w) <= PPW)
	    {
		maskpartialbits(pBox->x1, w, startmask);
		sx_set_1toN_operation(rop, startmask, pm1, pm2, pm3, pm4, planemask);
		sx_plane_select(planemask);
		srcy = srcyTmp;
		while (h--)
		{
		    *pdst = psrc[srcy];
		    ++srcy;
		    if (srcy == stippleHeight)
			srcy = 0;
		    pdst += nlwDst;
		}
	    }
	    else
	    {
		unsigned long bgbits;

		maskbits(pBox->x1, w, startmask, endmask, nlwMiddle);
	
		hTmp = h;
		pnext = pdst;

		if (startmask)
		{
		    srcy = srcyTmp;
		    sx_set_1toN_operation(rop, startmask, pm1, pm2, pm3, pm4, planemask);
		    sx_plane_select(planemask);
		    while (h--)
		    {
			*pdst = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
				srcy = 0;
			pdst += nlwDst;
		    }
		    pnext++;
		}

		sx_set_1toN_operation(rop, ~0, pm1, pm2, pm3, pm4, planemask);
		sx_plane_select(planemask);
		h = hTmp;
		srcy = srcyTmp;
		ptmp = pnext;
		while (h--)
		{
		    bits = psrc[srcy];
		    ++srcy;
		    if (srcy == stippleHeight)
			srcy = 0;
		    nlw = nlwMiddle;
		    pdst = ptmp;
		    Duff(nlw, *pdst++ = bits);
		    ptmp += nlwDst;
		}
		if (endmask)
		{
		    sx_set_1toN_operation(rop, endmask, pm1, pm2, pm3, pm4, planemask);
		    sx_plane_select(planemask);
		    srcy = srcyTmp;
		    h = hTmp;
		    pdst = pnext + nlwMiddle;
		    while (h--)
		    {
			*pdst = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
				srcy = 0;
			pdst += nlwDst;
		    }
		}
	    }
	    pBox++;
	}
    }
    else
    {
	int dstpljmp;
	register int plane;
	register unsigned long tmpsrc;
	OmronFbInfoPtr fbInfo;

	pbits = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwDst = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	dstpljmp = nlwDst * pDrawable->height;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( pbits, fbInfo ))
	    pbits = (int *) fbInfo->plane;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbfgmk[plane] = ((fg >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbbgmk[plane] = ((bg >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	}

	switch(rop)
	{
	    case GXcopy:
		BOXOPSTIP32(fnCOPY);
		break;
	    case GXxor:
		BOXOPSTIP32(fnXOR);
		break;
	    case GXand:
		BOXOPSTIP32(fnAND);
		break;
	    case GXor:
		BOXOPSTIP32(fnOR);
		break;
	    case GXset:
		BOXOPSTIP32(fnSET);
		break;
	    case GXclear:
		BOXOPSTIP32(fnCLEAR);
		break;
	    case GXandReverse:
		BOXOPSTIP32(fnANDREVERSE);
		break;
	    case GXandInverted:
		BOXOPSTIP32(fnANDINVERTED);
		break;
	    case GXnor:
		BOXOPSTIP32(fnNOR);
		break;
	    case GXequiv:
		BOXOPSTIP32(fnEQUIV);
		break;
	    case GXinvert:
		BOXOPSTIP32(fnINVERT);
		break;
	    case GXorReverse:
		BOXOPSTIP32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		BOXOPSTIP32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		BOXOPSTIP32(fnORINVERTED);
		break;
	    case GXnand:
		BOXOPSTIP32(fnNAND);
		break;
	    default:
		break;
	}
    }
}

#define BOXSTIP32(ROP) \
    while (nBox--) \
    { \
	w = pBox->x2 - pBox->x1; \
	height = pBox->y2 - pBox->y1; \
	iy = pBox->y1 % stippleHeight; \
	dstLine = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH); \
	if (((pBox->x1 & PIM) + w) <= PPW) \
	{ \
	    maskpartialbits(pBox->x1, w, startmask); \
	    for (plane = 0; plane < depth; plane++) \
	    { \
		if (cfbplmk[plane]) \
		{ \
		    h = height; srcy = iy; \
		    pdst = dstLine; \
		    while (h--) \
		    { \
			bits = psrc[srcy]; \
			++srcy; \
			if (srcy == stippleHeight) \
			    srcy = 0; \
			tmpsrc = bits & cfbfgmk[plane]; \
			*pdst = (ROP(tmpsrc, *pdst) & (startmask & bits)) | \
					(*pdst & ~(startmask & bits)); \
			pdst += nlwDst; \
		    } \
		} \
		dstLine += dstpljmp; \
	    } \
	} \
	else \
	{ \
	    maskbits(pBox->x1, w, startmask, endmask, nlwMiddle); \
	    nlwExtra = nlwDst - nlwMiddle; \
	    if (startmask && endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = bits & cfbfgmk[plane]; \
			    *pdst = (ROP(tmpsrc, *pdst) & (startmask & bits)) \
					| (*pdst & ~(startmask & bits)); \
			    pdst++; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = (ROP(tmpsrc, *pdst) & bits) | \
						(*pdst & ~bits); \
				pdst++; \
			    } \
			    *pdst = (ROP(tmpsrc, *pdst) & (endmask & bits)) \
					| (*pdst & ~(endmask & bits)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (startmask && !endmask) \
	    { \
		nlwExtra -= 1; \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = bits & cfbfgmk[plane]; \
			    *pdst = (ROP(tmpsrc, *pdst) & (startmask & bits)) \
					| (*pdst & ~(startmask & bits)); \
			    pdst++; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = (ROP(tmpsrc, *pdst) & bits) | \
						(*pdst & ~bits); \
				pdst++; \
			    } \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else if (!startmask && endmask) \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = bits & cfbfgmk[plane]; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = ((ROP(tmpsrc, *pdst) & bits) | \
						(*pdst & ~bits)); \
				pdst++; \
			    } \
			    *pdst = (ROP(tmpsrc, *pdst) & (endmask & bits)) \
					| (*pdst & ~(endmask & bits)); \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	    else \
	    { \
		for (plane = 0; plane < depth; plane++) \
		{ \
		    if (cfbplmk[plane]) \
		    { \
			h = height; srcy = iy; \
			pdst = dstLine; \
			while (h--) \
			{ \
			    bits = psrc[srcy]; \
			    ++srcy; \
			    if (srcy == stippleHeight) \
				srcy = 0; \
			    tmpsrc = bits & cfbfgmk[plane]; \
			    nlw = nlwMiddle; \
			    while (nlw--) \
			    { \
				*pdst = (ROP(tmpsrc, *pdst) & bits) | \
						(*pdst & ~bits); \
				pdst++; \
			    } \
			    pdst += nlwExtra; \
			} \
		    } \
		    dstLine += dstpljmp; \
		} \
	    } \
	} \
	pBox++; \
    }

void
cfbFillBoxStipple32 (pDrawable, pGC, nBox, pBox, stipple)
    DrawablePtr	    pDrawable;
    GCPtr           pGC;
    int		    nBox;	/* number of boxes to fill */
    register BoxPtr pBox;	/* pointer to list of boxes to fill */
    PixmapPtr	    stipple;	/* rotated, expanded stipple */
{
    register int *psrc;	/* pointer to bits in stipple, if needed */
    int stippleHeight;	/* height of the stipple */

    int nlwDst;		/* width in longwords of the dest pixmap */
    int w;		/* width of current box */
    register int h;	/* height of current box */
    unsigned long fg;		/* pixel value */
    unsigned long startmask;
    unsigned long endmask;	/* masks for reggedy bits at either end of line */
    int nlwMiddle;		/* number of longwords between sides of boxes */
    register int nlw;		/* loop version of nlwMiddle */
    register int *dstLine;
    register int *pdst;		/* pointer to bits we're writing */
    register int srcy;		/* current stipple position */
    int nlwExtra;

    int *pbits;				/* pointer to start of pixmap */
    register unsigned long bits;	/* bits from stipple */
    unsigned long planemask;
    int rop;
    int depth;

    if (pGC->alu == GXnoop || pGC->planemask == 0)
	return;

    rop = pGC->alu;
    depth = pDrawable->depth;
    fg = pGC->fgPixel;
    planemask = pGC->planemask;

    stippleHeight = stipple->drawable.height;
    psrc = (int *)stipple->devPrivate.ptr;

    if (pDrawable->type == DRAWABLE_WINDOW)
    {
	pbits = (int *)
		(((PixmapPtr)(pDrawable->pScreen->devPrivate))->devPrivate.ptr);
	nlwDst = (int)
		  (((PixmapPtr)(pDrawable->pScreen->devPrivate))->devKind) >> 2;

	sx_check_transparent(rop, ALL_ONE, fg, planemask);
	sx_plane_select(planemask);

	while (nBox--)
	{
	    w = pBox->x2 - pBox->x1;
	    h = pBox->y2 - pBox->y1;
	    srcy = pBox->y1 % stippleHeight;
	    pdst = pbits + (pBox->y1 * nlwDst) + (pBox->x1 >> PWSH);
	    if (((pBox->x1 & PIM) + w) <= PPW)
	    {
		maskpartialbits(pBox->x1, w, startmask);
		while (h--)
		{
		    bits = psrc[srcy];
		    ++srcy;
		    if (srcy == stippleHeight)
			srcy = 0;
		    *pdst = bits & startmask;
		    pdst += nlwDst;
		}
	    }
	    else
	    {
		maskbits(pBox->x1, w, startmask, endmask, nlwMiddle);
		nlwExtra = nlwDst - nlwMiddle;

		if (startmask && endmask)
		{
		    nlwExtra -= 1;
		    while (h--)
		    {
			bits = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
			    srcy = 0;
			*pdst = bits & startmask;
			pdst++;
			nlw = nlwMiddle;
			Duff(nlw, *pdst++ = bits);
			*pdst = bits & endmask;
			pdst += nlwExtra;
		    }
		}
		else if (startmask && !endmask)
		{
		    nlwExtra -= 1;
		    while (h--)
		    {
			bits = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
			    srcy = 0;
			*pdst = bits & startmask;
			pdst++;
			nlw = nlwMiddle;
			Duff(nlw, *pdst++ = bits);
			pdst += nlwExtra;
		    }
		}
		else if (!startmask && endmask)
		{
		    while (h--)
		    {
			bits = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
			    srcy = 0;
			nlw = nlwMiddle;
			Duff(nlw, *pdst++ = bits);
			*pdst = bits & endmask;
			pdst += nlwExtra;
		    }
		}
		else
		{
		    while (h--)
		    {
			bits = psrc[srcy];
			++srcy;
			if (srcy == stippleHeight)
			    srcy = 0;
			nlw = nlwMiddle;
			Duff(nlw, *pdst++ = bits);
			pdst += nlwExtra;
		    }
		}
	    }
	    pBox++;
	}
    }
    else
    {
	int iy, height, dstpljmp;
	register int plane;
	register unsigned long tmpsrc;
	OmronFbInfoPtr fbInfo;

	pbits = (int *)(((PixmapPtr)pDrawable)->devPrivate.ptr);
	nlwDst = (int)(((PixmapPtr)pDrawable)->devKind) >> 2;
	dstpljmp = nlwDst * pDrawable->height;
	fbInfo = getOmronFbInfo(pDrawable);
	if(isCommonPlane( pbits, fbInfo ))
	    pbits = (int *) fbInfo->plane;

	for (plane = 0; plane < depth; plane++)
	{
	    cfbfgmk[plane] = ((fg >> plane) & 0x1) ? ALL_ONE : ALL_ZERO;
	    cfbplmk[plane] = (planemask >> plane) & 0x1;
	}

	switch(rop)
	{
	    case GXcopy:
		BOXSTIP32(fnCOPY);
		break;
	    case GXxor:
		BOXSTIP32(fnXOR);
		break;
	    case GXand:
		BOXSTIP32(fnAND);
		break;
	    case GXor:
		BOXSTIP32(fnOR);
		break;
	    case GXset:
		BOXSTIP32(fnSET);
		break;
	    case GXclear:
		BOXSTIP32(fnCLEAR);
		break;
	    case GXandReverse:
		BOXSTIP32(fnANDREVERSE);
		break;
	    case GXandInverted:
		BOXSTIP32(fnANDINVERTED);
		break;
	    case GXnor:
		BOXSTIP32(fnNOR);
		break;
	    case GXequiv:
		BOXSTIP32(fnEQUIV);
		break;
	    case GXinvert:
		BOXSTIP32(fnINVERT);
		break;
	    case GXorReverse:
		BOXSTIP32(fnORREVERSE);
		break;
	    case GXcopyInverted:
		BOXSTIP32(fnCOPYINVERTED);
		break;
	    case GXorInverted:
		BOXSTIP32(fnORINVERTED);
		break;
	    case GXnand:
		BOXSTIP32(fnNAND);
		break;
	    default:
		break;
	}
    }
}
