/******************************************************************
(c) Copyright OMRON Corporation 1990

                        All Rights Reserved

******************************************************************/

#ifdef UniOSU
#include  <sys/sys9100.h>
#include  <sys/mman.h>
#include  <sys/devmap.h>
#else
#ifdef MACH88K 
#include <sys/types.h>
#include <dev/fbmap.h>
#include  <sys/mman.h>
#else
#include  <om68k/sysomron.h>
#include  <sys/mman.h>
#include  <om68kdev/fbmap.h>
#endif /* MACH88K */ 
#endif

#include "omronFb.h" 
#include "omronFbFunc.h"

#ifndef MONO_ONLY
#include "X.h"
#include "Xproto.h"
#endif

#include "misc.h"
#include "scrnintstr.h"
#include "screenint.h"
#ifndef MONO_ONLY
#include "resource.h"
#include "colormapst.h"
#endif

#include "mipointer.h"

static int r88k_bm_depth;

static R88kBmRegPtr r88k_bm_reg;
static union palette *r88k_bm_pal;

static int r88k_allmap_fb;
static int r88k_fb_fd;
static int r88k_pal_fd;

static struct pal{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
} paldata[16],palsave[16];


static omron88kBmScreenIndex;
static unsigned long omron88kBmGeneration = 0;
static ColormapPtr pInstalledMap;

extern int omronScreenIndex;	
extern unsigned long omronGeneration; 

extern int monitorResolution;

#ifndef MONO_ONLY
extern void omron88kBmInstallColormap();
extern void omron88kBmUnInstallColormap();
extern int  omron88kBmListInstalledColormaps();
extern void omron88kBmStoreColors();
#endif

omron88kBmCreate(omron_fb_info)
OmronFbInfoPtr omron_fb_info;
{
	R88kBmMapPtr r88k_bm_map;
	register int i,j;

	if ((r88k_fb_fd = open("/dev/fb",2)) < 0) {
		Error("Can't open /dev/fb");
	}

	r88k_bm_map = (R88kBmMapPtr)0xb1080008;

	if ( ioctl(r88k_fb_fd,FBIOCBATC,&(caddr_t *)r88k_bm_map) < 0 ) {
		Error("ioctl FBIOCBATC error.");
	}

	omron_fb_info->fb_map =(char *)r88k_bm_map;

	omron_fb_info->cplane =(char *)&(r88k_bm_map->cbmplane.sd[0][0][0]);
	omron_fb_info->plane = (char *)&(r88k_bm_map->bmplane.sd[0][0][0]);	


	if ((r88k_allmap_fb = open("/dev/allmapfb",2)) < 0) { 
		Error("Can't allocate 88k_bm_reg.");
	}
 
	if((r88k_bm_reg = ( R88kBmRegPtr )valloc(sizeof( struct R88k_bm_fbreg))) == ( R88kBmRegPtr ) NULL) {
		Error("Can't allocate 88k_bm_reg.");
	}

	if(mmap(r88k_bm_reg,sizeof(struct R88k_bm_fbreg),PROT_WRITE,MAP_SHARED,r88k_allmap_fb,0) < 0 ) {
		Error("Can't mmap /dev/allmapfb");
		free(r88k_bm_reg);
	}

	sx_pselect_reg = &(r88k_bm_reg->pselect.reg);

	*sx_pselect_reg = (1<<omron_fb_info->fb_depth)-1;

	sx_refresh_reg = &(r88k_bm_reg->refresh.reg);


	for(j = 0;j < 16;j++) {
		sx_op_cont0[j] =
		&(r88k_bm_map->cplane.op_cont[gmwtosxop[j]]);
		sx_conv_op_cont0[j] =
		&(r88k_bm_map->cplane.op_cont[gmwtosxop[CONV_OP(j)]]);
		sx_trans_op_cont0[j] =
		&(r88k_bm_map->cplane.op_cont[gmwtosxop[TRANS_OP(j)]]);
		sx_trans_conv_op_cont0[j] =
		&(r88k_bm_map->cplane.op_cont[gmwtosxop[TRANS_CONV_OP(j)]]);
	}

	r88k_bm_depth = omron_fb_info->fb_depth;	

	for(i = 0;i < omron_fb_info->fb_depth;i++) {
		for(j=0;j < 16;j++) {
			sx_op_cont[i][j] =
			&(r88k_bm_map->planes[i+1].op_cont[gmwtosxop[j]]);
			sx_conv_op_cont[i][j] =
			&(r88k_bm_map->planes[i+1].op_cont[gmwtosxop[CONV_OP(j)]]);
			sx_trans_op_cont[i][j] =
			&(r88k_bm_map->planes[i+1].op_cont[gmwtosxop[TRANS_OP(j)]]);
			sx_trans_conv_op_cont[i][j] =
			&(r88k_bm_map->planes[i+1].op_cont[gmwtosxop[TRANS_CONV_OP(j)]]);
		}
	}

	sx_plane_mask = (1 << r88k_bm_depth) - 1;

	omron88kBmPalCreate();
	omron88kBmPalInit();

	if (omron_fb_info->fb_type == DT_PLASMA)
		*sx_refresh_reg = 0x100000;
	else
		*sx_refresh_reg = 0xff07f7e5;

}

omron88kBmSaveScreen(pScreen, on)
ScreenPtr     pScreen;
Bool          on;
{
/*
	struct pal savepal[16]; 	
	register int i;

	if (on != SCREEN_SAVER_ON) {
		SetTimeSinceLastInputEvent();
		omron88kBmSetPal(palsave);
		return TRUE;
	}

	omron88kBmGetPal(palsave);

	for( i = 0 ; i < 16 ; i++)
	{
		savepal[i].red = 0x0;
		savepal[i].green = 0x0;
		savepal[i].blue = 0x0;
	}
	omron88kBmSetPal(savepal);
*/
	
	return FALSE;
}

omron88kBmInit(index, pScreen, argc, argv)
    int           index;
    ScreenPtr     pScreen;
    int           argc;
    char          **argv;
{
	OmronFbInfoPtr pFbInfo;
	extern miPointerCursorFuncRec  omronPointerCursorFuncs;
	Bool omron88kBmCloseScreen();
	
	if (omron88kBmGeneration != serverGeneration)
	{
		if((omron88kBmScreenIndex = AllocateScreenPrivateIndex()) <0){
			Error("AllocateScreenPrivateIndex Error\n");
			return FALSE;
		}
		omron88kBmGeneration = serverGeneration;
	}

	pFbInfo = (OmronFbInfoPtr) pScreen->devPrivates[omronScreenIndex].ptr;

	if(pFbInfo->fb_depth == 1)
	{
		if ( !monitorResolution )
			monitorResolution = MONO_TV_RESOLUTION; 

		if(!mfbScreenInit(pScreen,(pointer)pFbInfo->plane,pFbInfo->scr_width,pFbInfo->scr_height,
			monitorResolution,monitorResolution,pFbInfo->fb_width)){
			Error("mfbScreenInit Error\n");
			return (FALSE);
		}

    		pScreen->whitePixel = 0;
    		pScreen->blackPixel = 1;

		miDCInitialize (pScreen, &omronPointerCursorFuncs);

		mfbCreateDefColormap(pScreen);

	} else {
#ifndef MONO_ONLY
		if ( !monitorResolution )
			monitorResolution = COLOR_TV_RESOLUTION; 

		if(!cfbScreenInit(pScreen,pbits,pFbInfo->scr_width,pFbInfo->scr_height,
				monitorResolution, monitorResolution,pFbInfo->fb_width,pFbInfo->fb_depth)) {
			Error("cfbScreenInit Error");
			return (FALSE);
		}
		
    		pScreen->InstallColormap = omron88kBmInstallColormap;
    		pScreen->UninstallColormap = omron88kBmUninstallColormap;
    		pScreen->ListInstalledColormaps = omron88kBmListInstalledColormaps;
    		pScreen->StoreColors = omron88kBmStoreColors;
		miDCInitialize (pScreen, &omronPointerCursorFuncs);
		cfbCreateDefColormap(pScreen);
#endif
	}

	pScreen->SaveScreen = omron88kBmSaveScreen;
	pScreen->devPrivates[omron88kBmScreenIndex].ptr = (pointer) pScreen->CloseScreen;
	pScreen->CloseScreen = omron88kBmCloseScreen;
	omron88kBmSaveScreen(pScreen,SCREEN_SAVER_FORCER );

	return TRUE;

}

omron88kBmCloseScreen(i,pScreen)
int		i;
ScreenPtr	pScreen;
{
  Bool ret;

	omron88kBmClearScreen(pScreen);
	pScreen->CloseScreen = (Bool (*)()) pScreen->devPrivates[omron88kBmScreenIndex].ptr;
	ret = (*pScreen->CloseScreen)(i, pScreen);
/*
	omron88kBmSetPal(paldata);
*/
	if(ioctl(r88k_pal_fd, PLTIOCDISP, 0) < 0)
	{
		Error("ioctl PLTIOCUND error.");
		return FALSE;
	}
	munmap(r88k_bm_reg,sizeof(union palette));
	munmap(r88k_bm_pal,sizeof(union palette));
	close(r88k_allmap_fb);
	close(r88k_fb_fd);
	close(r88k_pal_fd);
	ResetConsoleMode();
	return(ret);
}

omron88kBmPalCreate()
{
/* 
	if((r88k_bm_pal = (union palette *)valloc(sizeof(union palette))) == (union palette *) NULL){
		Error("Can't allocate palette.");
		return FALSE;	
	}

	if (mmap(r88k_bm_pal, sizeof(union palette), PROT_WRITE, MAP_SHARED, r88k_allmap_fb, 0x10000000) < 0) { 
		Error("Can't mmap palette.");
		free(r88k_bm_pal);
		return FALSE;
	}	

	lseek(r88k_allmap_fb,0x10000000,1);

	if(ioctl(r88k_allmap_fb, PLTIOCUND, 0) < 0)
	{
		Error("ioctl PLTIOCUND error.");
		return FALSE;
	}
*/
	if ((r88k_pal_fd = open("/dev/palette",2)) < 0) {
		Error("Can't open /dev/fb");
	}

	if((r88k_bm_pal = (union palette *)valloc(sizeof(union palette))) == (union palette *) NULL){
		Error("Can't allocate palette.");
		return FALSE;	
	}

	if (mmap(r88k_bm_pal, sizeof(union palette), PROT_WRITE, MAP_SHARED, r88k_pal_fd, 0) < 0) { 
		Error("Can't mmap palette.");
		free(r88k_bm_pal);
		return FALSE;
	}	


	if(ioctl(r88k_pal_fd, PLTIOCUND, 0) < 0)
	{
		Error("ioctl PLTIOCUND error.");
		return FALSE;
	}

	return TRUE; 
}


omron88kBmPalInit()
{
/* 88k can't read palette.
	omron88kBmGetPal(paldata);
*/
}


omron88kBmGetPal(pal)
struct pal *pal;

{
	unsigned char    *palp;
	register	 int        i,j;

	/* save the CPU ROM palette setting */
	for (i = 0; i < 16; i++) {
		palp = &pal++->red;
		r88k_bm_pal->reg.addr = i << 4;
		for (j = 0; j < 3; j++)
			*palp++ = r88k_bm_pal->reg.coldata;	
	}
}

omron88kBmSetPal(pal)
struct pal *pal;
{
	register	int    i,j;
	unsigned char    *palp;

	/* restore palette data */
	for (i = 0; i < 16; i++) {
		palp = &pal++->red;
		r88k_bm_pal->reg.addr = i << 4;
		for (j = 0; j < 3; j++)
			r88k_bm_pal->reg.coldata = *palp++;
	}
}

omron88kBmPrintPal(pal)
struct pal *pal;
{
	register	int    i,j;
	unsigned char    *palp;

	/* restose palette data */
	for (i = 0; i < 16; i++) {
		ErrorF("\n index = %d\n",i);
		palp = &pal++->red;
		for (j = 0; j < 3; j++)
			ErrorF("%d ",*palp++ >> 4);
	}
}

omron88kBmClearScreen(pScreen)
ScreenPtr       pScreen;
{
	OmronFbInfoPtr pFbInfo;
	register int *j;
	register int nw,height;
	int	nwidth,nlwidth,nlwExtra;

	pFbInfo = (OmronFbInfoPtr) pScreen->devPrivates[omronScreenIndex].ptr;
	j = (int *)pFbInfo->cplane;
	nlwidth = (pFbInfo->fb_width)>>5;
	nwidth = (pScreen->width)>>5;
	nlwExtra = nlwidth - nwidth;
	height =pScreen->height;

	sx_set_operation_all( 3 /* GXcopy*/, ~0 );

	while(height--)
	{
		nw = nwidth; 
		while(nw--)
			*j++ = 0;
		j += nlwExtra; 
	}

}


#ifndef MONO_ONLY

/* TORIAEZU VERSION */
static	char	pixConvTbl[16] =
{
	0,	8,	4,	0xC,	2,	0xA,	0x6,	0xE,
	1,	9,	5,	0xD,	3,	0xB,	0x7,	0xF
};

void
omron88kBmStoreColors(pmap, ndef, pdefs)
ColormapPtr pmap;
int         ndef;
xColorItem  *pdefs;
{
	register unsigned char *palr = &(r88k_bm_pal->reg.coldata);
	register unsigned char *palg = &(r88k_bm_pal->reg.coldata);
	register unsigned char *palb = &(r88k_bm_pal->reg.coldata);

	if (pmap != pInstalledMap)
		return;

	while (ndef--) {
		dt_bm_pal->reg.addr = pixConvTbl[pdefs->pixel] << 4;
		*palr = pdefs->red >> 8;
		*palg = pdefs->green >> 8;
		*palb = pdefs->blue >> 8;
		pdefs++;
	}
}

void
omron88kBmInstallColormap(pcmap)
ColormapPtr     pcmap;
{
	int		entries = pcmap->pVisual->ColormapEntries;
	Pixel  		*ppix;
	xrgb		*prgb;
	xColorItem	*defs;
	register int 	i;
	 
	if (pcmap == pInstalledMap)
		return;

	ppix = (Pixel *)ALLOCATE_LOCAL( entries * sizeof(Pixel));
	prgb = (xrgb *)ALLOCATE_LOCAL( entries * sizeof(xrgb));
	defs = (xColorItem *)ALLOCATE_LOCAL(entries * sizeof(xColorItem));

	if (pInstalledMap)
		WalkTree( pcmap->pScreen, TellLostMap, &pInstalledMap->mid);
	pInstalledMap = pcmap;
	for ( i=0; i<entries; i++)
		ppix[i] = i;
	QueryColors( pcmap, entries, ppix, prgb);
	for ( i=0; i<entries; i++)
	{
		defs[i].pixel = ppix[i];
		defs[i].red = prgb[i].red;
		defs[i].green = prgb[i].green;
		defs[i].blue = prgb[i].blue;
		defs[i].flags =  DoRed|DoGreen|DoBlue;
	}
	omron88kBmStoreColors( pcmap, entries, defs);
	WalkTree(pcmap->pScreen, TellGainedMap, &pcmap->mid);
	DEALLOCATE_LOCAL(ppix);
	DEALLOCATE_LOCAL(prgb);
	DEALLOCATE_LOCAL(defs);
}
		
void
omron88kBmUnInstallColormap(pcmap)
ColormapPtr 	pcmap;
{
	 ColormapPtr defColormap;

	if ( pcmap != pInstalledMap)
		return;

	defColormap = (ColormapPtr) LookupIDByType( pcmap->pScreen->defColormap,
			RT_COLORMAP);

	if (defColormap == pInstalledMap)
		return;

	(*pcmap->pScreen->InstallColormap) (defColormap);
}	

int
omron88kBmListInstalledColormaps( pscr, pcmaps)
ScreenPtr 	pscr;
Colormap	*pcmaps;
{
	*pcmaps = pInstalledMap->mid;
	return 1;
} 
#endif
